"Filed out from Dolphin Smalltalk 99 release 3.0"!

Container subclass: #Location
	instanceVariableNames: 'connections lighted world hasWater hasOil'
	classVariableNames: ''
	poolDictionaries: ''!

Location class instanceVariableNames: ''!

Location comment: ''!

Location guid: (GUID fromString: '{B1FE94A9-54A3-11D3-8268-00001D19F5C2}')!

!Location categoriesForClass!Adventure! !

!Location methodsFor!

addConnection: aConnection
	self connections add: aConnection!

allDirections
	"Answers a collection of all directions which are valid in this location"

	| allDirections |

	allDirections := OrderedCollection new initialize.

	self connections do: [ :each |
		each synonyms do: [ :each2 |
			(allDirections includes: each2) ifFalse: [ allDirections add: each2 ] ] ].

	^allDirections!

allowTravelBy: anActor through: aConnection
	^true!

basicLighted
	^lighted!

connections
	connections isNil ifTrue: [ connections := OrderedCollection new ].
	^connections!

connectionsTo: aString
	^self connections select: [ :each | (each hasSynonym: aString) & (each entryProbability >= self randomGenerator next) ]!

description
	| connectionDescription |

	self lighted
		ifTrue: [
			connectionDescription := self connections inject: '' into: [ :sum :each | sum, each description ].
			^super description,
				(connectionDescription size > 0 ifTrue: [ String lineDelimiter ] ifFalse: ['']),
				connectionDescription ]
		ifFalse: [ ^self class chooseFrom: #( 'Gee, it''s awfully dark in here...'
									'You have wandered into a dark place.  You may be eaten by a grue...'
									'<gulp!!>  Have I m-m-mentioned I''m afraid of the d-d-d-d-dark?') ]!

hasOil
	"Answer the value of the receiver's instance variable hasOil.
	This method was automatically generated, but may be modified."

	^hasOil!

hasOil: anObject
	"Set the value of the receiver's instance variable hasOil to anObject.
	This method was automatically generated, but may be modified."

	hasOil := anObject!

hasWater
	"Answer the value of the receiver's instance variable hasWater.
	This method was automatically generated, but may be modified."

	^hasWater!

hasWater: anObject
	"Set the value of the receiver's instance variable hasWater to anObject.
	This method was automatically generated, but may be modified."

	hasWater := anObject!

initialize
	super initialize.
	self
		lighted: true;
		hasWater: false;
		hasOil: false!

inventory
	"Answer a string describing the contents of this container"

	self lighted
		ifTrue: [ ^self inventory3dPersonWithPrefix: 'There' suffix: 'here' ]
		ifFalse: [ ^'' ]!

inventoryWithPrefix: aPrefixString suffix: aSuffixString
	self lighted
		ifTrue: [ ^super inventoryWithPrefix: aPrefixString suffix: aSuffixString ]
		ifFalse: [ ^'' ]!

lighted
	^self basicLighted | self containsLightSource!

lighted: aBoolean
	"Set the value of the receiver's instance variable lighted to anObject.
	This method was automatically generated, but may be modified."

	lighted := aBoolean!

receiveActor: anActor
	anActor location notNil ifTrue: [ anActor location remove: anActor ].
	anActor location: self.
	self add: anActor.
	^anActor location description, String lineDelimiter, anActor location inventory
!

removeConnection: aConnection
	self connections remove: aConnection ifAbsent: [ ]!

travelFailureReasonFor: anActor through: aConnection
	^''!

world
	"Answer the value of the receiver's instance variable world.
	This method was automatically generated, but may be modified."

	^world!

world: anObject
	"Set the value of the receiver's instance variable world to anObject.
	This method was automatically generated, but may be modified."

	world := anObject! !

!Location categoriesFor: #addConnection:!*-unclassified!public! !
!Location categoriesFor: #allDirections!*-unclassified!public! !
!Location categoriesFor: #allowTravelBy:through:!*-unclassified!public! !
!Location categoriesFor: #basicLighted!*-unclassified!public! !
!Location categoriesFor: #connections!*-unclassified!public! !
!Location categoriesFor: #connectionsTo:!*-unclassified!public! !
!Location categoriesFor: #description!*-unclassified!public! !
!Location categoriesFor: #hasOil!accessing!public! !
!Location categoriesFor: #hasOil:!accessing!public! !
!Location categoriesFor: #hasWater!accessing!public! !
!Location categoriesFor: #hasWater:!accessing!public! !
!Location categoriesFor: #initialize!*-unclassified!public! !
!Location categoriesFor: #inventory!*-unclassified!public! !
!Location categoriesFor: #inventoryWithPrefix:suffix:!*-unclassified!public! !
!Location categoriesFor: #lighted!accessing!public! !
!Location categoriesFor: #lighted:!accessing!public! !
!Location categoriesFor: #receiveActor:!*-unclassified!public! !
!Location categoriesFor: #removeConnection:!*-unclassified!public! !
!Location categoriesFor: #travelFailureReasonFor:through:!*-unclassified!public! !
!Location categoriesFor: #world!accessing!public! !
!Location categoriesFor: #world:!accessing!public! !

